UNIT config;
(* Program: Duke of Dragonfear: Deathland.
 * Description: Manages the game configuration.
 *		It's a good idea to keep all the configuration values at the
 *		same place.
 * Author: uo Martnez <niunio@users.sourceforge.net>
 *)

INTERFACE



VAR
(* Variables containing the configuration. *)
  FullScreen: BOOLEAN; {<If false, windowed. }
  DataDirectory: STRING; {<Path to directory where data is. }


(* Gets the configuration values and puts them into the variables. *)
  PROCEDURE GetConfiguration;



IMPLEMENTATION

USES
  allegro,
  sysutils;



(* Gets the configuration values and puts them in its variables. *)
  PROCEDURE GetConfiguration;
  VAR
    Cnt: INTEGER;
  BEGIN
  { Set an additional config data file in the configuration directory. }
    al_override_config_file (GetAppConfigFile (FALSE));
  { Load the configuration values.  Note: Allegro gets some values from the
    configuration file for internal purposes.  Read the documentation. }
    FullScreen := (al_get_config_string ('graphics', 'fullscreen', 'true') = 'true');
  { Check the command line parameters. }
    FOR Cnt := 1 TO PARAMCOUNT DO
    BEGIN
      IF PARAMSTR (Cnt) = '-windowed' THEN
	FullScreen := FALSE
      ELSE IF PARAMSTR (Cnt) = '-fullscreen' THEN
	FullScreen := TRUE;
    END;
  { Data directory. }
    DataDirectory := './';
  END;

END.
