UNIT error;
(* Program: Demo game for the Allegro.pas library.
 * File: error.pas
 * Description: To show nice error messages.
 * Author: uo Martnez <>
 *)
(*
  Copyright (c) 2011 Guillermo Martnez J.

  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
    claim that you wrote the original software. If you use this software
    in a product, an acknowledgment in the product documentation would be
    appreciated but is not required.

    2. Altered source versions must be plainly marked as such, and must not be
    misrepresented as being the original software.

    3. This notice may not be removed or altered from any source
    distribution.
*)

INTERFACE

(* Shows a simple error message. *)
  PROCEDURE Show (Message: STRING);



IMPLEMENTATION

USES
  allegro;



(* Shows a simple error message. *)
  PROCEDURE Show (Message: STRING);

  (* Helper function. *)
    PROCEDURE DrawText (y: INTEGER; aText: STRING);
    BEGIN
      al_textout_centre_ex (al_screen, al_font, aText,
			    AL_SCREEN_W DIV 2, y,
			    al_makecol (255, 255, 255), -1);
    END;

  CONST
    PressKey = 'Press <Esc> key to continue';
  BEGIN
    al_rectfill (al_screen, 0, (AL_SCREEN_H * 2) DIV 5,
	         AL_SCREEN_W, (AL_SCREEN_H * 3) DIV 5, al_makecol (128, 0, 0));
    al_rect (al_screen, 0, (AL_SCREEN_H * 2) DIV 5,
	     AL_SCREEN_W, (AL_SCREEN_H * 3) DIV 5, al_makecol (255, 255, 255));
    DrawText ((AL_SCREEN_H DIV 2) - 12, Message);
    DrawText ((AL_SCREEN_H DIV 2) +  4, PressKey);
    WHILE (al_readkey SHR 8) <> AL_KEY_ESC DO
      al_rest (100);
  END;

END.
