UNIT title;
(* Duke of Dragonfear: Deathland.
 *	An action game for the 1st Pascal Game Development Mini Contest.
 *
 * The game title.  It also checks if player wants to play or exit.
 *)
(*
  Copyright (c) 2011 Guillermo Martínez J.

  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
    claim that you wrote the original software. If you use this software
    in a product, an acknowledgment in the product documentation would be
    appreciated but is not required.

    2. Altered source versions must be plainly marked as such, and must not be
    misrepresented as being the original software.

    3. This notice may not be removed or altered from any source
    distribution.
*)

INTERFACE

(* Runs it.  Returns TRUE if player wants to play or FALSE to exit. *)
  FUNCTION Run: BOOLEAN;

IMPLEMENTATION

USES
  graphsys,
  allegro, sysutils;

CONST
  FADE_SPEED = 10;



(* Runs it.  Returns TRUE if player wants to play or FALSE to exit. *)
  FUNCTION Run: BOOLEAN;
  VAR
    Title: AL_BITMAPptr;
  BEGIN
    Run := FALSE;
    graphsys.FadeOut (FADE_SPEED);
    Title := al_create_bitmap (VisualPage^.w, VisualPage^.h);
    IF Title = NIL THEN
      RAISE Exception.Create ('Can''t create title!');
    TRY
      al_textout_centre_ex (Title, al_font, 'Duke of Dragonfear - Deathland',
	Title^.w DIV 2, 16, al_makecol (0, 0, 255), -1);
      al_textout_centre_ex (Title, al_font, 'Game concept prototype',
	Title^.w DIV 2, 24, al_makecol (128, 128, 128), -1);
      al_textout_centre_ex (Title, al_font, 'Press [Esc] to exit',
	Title^.w DIV 2, 240, al_makecol (255, 255, 255), -1);
      al_textout_centre_ex (Title, al_font, 'Press any other key to test it',
	Title^.w DIV 2, 248, al_makecol (255, 255, 255), -1);
      al_textout_centre_ex (Title, al_font, '(c) Ñuño Martínez 2011',
	Title^.w DIV 2, 448, al_makecol (128, 128, 128), -1);
      graphsys.FadeTo (Title, FADE_SPEED);
      al_clear_keybuf;
      Run := (al_readkey SHR 8) <> AL_KEY_ESC;
    FINALLY
      al_destroy_bitmap (Title);
    END;
  END;

END.

